<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class hasWordTokens
{
    /**
     * Handle an incoming request.
     *
     * @param  Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next): Response
    {
        if (Auth::user()->remaining_words == -1 or Auth::user()->remaining_words > 0) {
            return $next($request);
        }

        return back()->with(['message' => 'Insufficient credits to create.', 'type' => 'error']);
    }
}
